/* Testscore.c David Loewenstern 1997.
   This program _ought_ to be written in Perl, but we can't guarantee that
   we have Perl.  Ah, well.

   */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void usage(char *name) {
  fprintf(stderr,"Usage: %s cdna-output-file expected-score tolerance\n",name);
  exit(-1);
}


main(int argc, char *argv[]) {
  char *outf,line[1000];
  float expsc,tol,sc;
  FILE *f;
    
  if (argc!=4) 
    usage(argv[0]);
  outf=argv[1];
  expsc=atof(argv[2]);
  tol=atof(argv[3]);
  if (tol<=0 || expsc<0) 
    usage(argv[0]);
  f=fopen(outf,"r");
  sc=-1;
  while(fgets(line,1000,f) && sc==-1) {
    if (strncmp(line,"Average bits =",14)==0) 
      sc=atof(&(line[14]));
  }
  fclose(f);
  if (sc==-1) {
    printf("%s: No entropy rate found.\n",outf);
    exit(-1);
  } else if(((expsc>sc)?(expsc-sc):(sc-expsc))>tol) {
    printf("%s: Entropy rate of %f not within %f of %f\n",
	   outf,sc,tol,expsc);
    exit(-2);
  } else {
    printf("%s: OK\n",outf);
    exit(0);
  }
}

      

  



  

     
     
  
  
